# GstCollectPads

Manages a set of pads that operate in collect mode. This means that control is given to the manager of this object when all pads have data.

- Collectpads are created with gst_collect_pads_new. A callback should then be installed with gst_collect_pads_set_function ().

- Pads are added to the collection with gst_collect_pads_add_pad/ gst_collect_pads_remove_pad. The pad has to be a sinkpad. When added, the chain, event and query functions of the pad are overridden. The element_private of the pad is used to store private information for the collectpads.

- For each pad, data is queued in the _chain function or by performing a pull_range.

- When data is queued on all pads in waiting mode, the callback function is called.

- Data can be dequeued from the pad with the gst_collect_pads_pop method. One can peek at the data with the gst_collect_pads_peek function. These functions will return NULL if the pad received an EOS event. When all pads return NULL from a gst_collect_pads_peek, the element can emit an EOS event itself.

- Data can also be dequeued in byte units using the gst_collect_pads_available, gst_collect_pads_read_buffer and gst_collect_pads_flush calls.

- Elements should call gst_collect_pads_start and gst_collect_pads_stop in their state change functions to start and stop the processing of the collectpads. The gst_collect_pads_stop call should be called before calling the parent element state change function in the PAUSED_TO_READY state change to ensure no pad is blocked and the element can finish streaming.

- gst_collect_pads_set_waiting sets a pad to waiting or non-waiting mode. CollectPads element is not waiting for data to be collected on non-waiting pads. Thus these pads may but need not have data when the callback is called. All pads are in waiting mode by default.

## GstCollectData

Structure used by the collect_pads.

### Members

`collect` (GstCollectPads *) –

owner GstCollectPads

`pad` (GstPad *) –

GstPad managed by this data

`buffer` (GstBuffer *) –

currently queued buffer.

`pos` (guint) –

position in the buffer

`segment` (GstSegment) –

last segment received.

`ABI.abi.dts` (gint64) –

the signed version of the DTS converted to running time. To access this member, use GST_COLLECT_PADS_DTS macro. (Since: 1.6)

## GstBase.CollectData

Structure used by the collect_pads.

### Members

`collect` (GstBase.CollectPads) –

owner GstBase.CollectPads

`pad` (Gst.Pad) –

Gst.Pad managed by this data

`buffer` (Gst.Buffer) –

currently queued buffer.

`pos` (Number) –

position in the buffer

`segment` (Gst.Segment) –

last segment received.

## GstBase.CollectData

Structure used by the collect_pads.

### Members

`collect` (GstBase.CollectPads) –

owner GstBase.CollectPads

`pad` (Gst.Pad) –

Gst.Pad managed by this data

`buffer` (Gst.Buffer) –

currently queued buffer.

`pos` (int) –

position in the buffer

`segment` (Gst.Segment) –

last segment received.

## GstCollectPads

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstCollectPads

Collectpads object.

### Members

`object` (GstObject) –
No description available
`data` (GSList *) –

GList of GstCollectData managed by this GstCollectPads.

### Class structure

#### GstCollectPadsClass

##### Fields

`parent_class` (GstObjectClass) –
No description available

### GstBase.CollectPadsClass

##### Attributes

`parent_class` (Gst.ObjectClass) –
No description available

### GstBase.CollectPadsClass

##### Attributes

`parent_class` (Gst.ObjectClass) –
No description available

## GstBase.CollectPads

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──GstBase.CollectPads

Collectpads object.

### Members

`object` (Gst.Object) –
No description available
`data` (GLib.SList) –

GLib.List of GstBase.CollectData managed by this GstBase.CollectPads.

## GstBase.CollectPads

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──GstBase.CollectPads

Collectpads object.

### Members

`object` (Gst.Object) –
No description available
`data` (GLib.SList) –

GLib.List of GstBase.CollectData managed by this GstBase.CollectPads.

### Constructors

#### gst_collect_pads_new

    GstCollectPads *
    gst_collect_pads_new ()

Create a new instance of GstCollectPads.

MT safe.

Returns ( [transfer: full]) –

a new GstCollectPads, or NULL in case of an error.

#### GstBase.CollectPads.prototype.new

    function GstBase.CollectPads.prototype.new(): {
        // javascript wrapper for 'gst_collect_pads_new'
    }

Create a new instance of GstBase.CollectPads.

MT safe.

Returns (GstBase.CollectPads) –

a new GstBase.CollectPads, or null in case of an error.

#### GstBase.CollectPads.new

    def GstBase.CollectPads.new ():
        #python wrapper for 'gst_collect_pads_new'

Create a new instance of GstBase.CollectPads.

MT safe.

Returns (GstBase.CollectPads) –

a new GstBase.CollectPads, or None in case of an error.

### Methods

#### gst_collect_pads_add_pad

    GstCollectData *
    gst_collect_pads_add_pad (GstCollectPads * pads,
                              GstPad * pad,
                              guint size,
                              GstCollectDataDestroyNotify destroy_notify,
                              gboolean lock)

Add a pad to the collection of collect pads. The pad has to be a sinkpad. The refcount of the pad is incremented. Use gst_collect_pads_remove_pad to remove the pad from the collection again.

You specify a size for the returned GstCollectData structure so that you can use it to store additional information.

You can also specify a GstCollectDataDestroyNotify that will be called just before the GstCollectData structure is freed. It is passed the pointer to the structure and should free any custom memory and resources allocated for it.

Keeping a pad locked in waiting state is only relevant when using the default collection algorithm (providing the oldest buffer). It ensures a buffer must be available on this pad for a collection to take place. This is of typical use to a muxer element where non-subtitle streams should always be in waiting state, e.g. to assure that caps information is available on all these streams when initial headers have to be written.

The pad will be automatically activated in push mode when pads is started.

MT safe.

Parameters:

`pads` –

the collectpads to use

`pad` ( [transfer: none]) –

the pad to add

`size` –

the size of the returned GstCollectData structure

`destroy_notify` ( [scope async]) –

function to be called before the returned GstCollectData structure is freed

`lock` –

whether to lock this pad in usual waiting state

Returns ( [nullable][transfer: none]) –

a new GstCollectData to identify the new pad. Or NULL if wrong parameters are supplied.

#### GstBase.CollectPads.prototype.add_pad

    function GstBase.CollectPads.prototype.add_pad(pad: Gst.Pad, size: Number, destroy_notify: GstBase.CollectDataDestroyNotify, lock: Number): {
        // javascript wrapper for 'gst_collect_pads_add_pad'
    }

Add a pad to the collection of collect pads. The pad has to be a sinkpad. The refcount of the pad is incremented. Use GstBase.CollectPads.prototype.remove_pad to remove the pad from the collection again.

You specify a size for the returned GstBase.CollectData structure so that you can use it to store additional information.

You can also specify a GstBase.CollectDataDestroyNotify that will be called just before the GstBase.CollectData structure is freed. It is passed the pointer to the structure and should free any custom memory and resources allocated for it.

Keeping a pad locked in waiting state is only relevant when using the default collection algorithm (providing the oldest buffer). It ensures a buffer must be available on this pad for a collection to take place. This is of typical use to a muxer element where non-subtitle streams should always be in waiting state, e.g. to assure that caps information is available on all these streams when initial headers have to be written.

The pad will be automatically activated in push mode when pads is started.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`pad` (Gst.Pad) –

the pad to add

`size` (Number) –

the size of the returned GstBase.CollectData structure

`destroy_notify` (GstBase.CollectDataDestroyNotify) –

function to be called before the returned GstBase.CollectData structure is freed

`lock` (Number) –

whether to lock this pad in usual waiting state

Returns (GstBase.CollectData) –

a new GstBase.CollectData to identify the new pad. Or null if wrong parameters are supplied.

#### GstBase.CollectPads.add_pad

    def GstBase.CollectPads.add_pad (self, pad, size, destroy_notify, lock):
        #python wrapper for 'gst_collect_pads_add_pad'

Add a pad to the collection of collect pads. The pad has to be a sinkpad. The refcount of the pad is incremented. Use GstBase.CollectPads.remove_pad to remove the pad from the collection again.

You specify a size for the returned GstBase.CollectData structure so that you can use it to store additional information.

You can also specify a GstBase.CollectDataDestroyNotify that will be called just before the GstBase.CollectData structure is freed. It is passed the pointer to the structure and should free any custom memory and resources allocated for it.

Keeping a pad locked in waiting state is only relevant when using the default collection algorithm (providing the oldest buffer). It ensures a buffer must be available on this pad for a collection to take place. This is of typical use to a muxer element where non-subtitle streams should always be in waiting state, e.g. to assure that caps information is available on all these streams when initial headers have to be written.

The pad will be automatically activated in push mode when pads is started.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`pad` (Gst.Pad) –

the pad to add

`size` (int) –

the size of the returned GstBase.CollectData structure

`destroy_notify` (GstBase.CollectDataDestroyNotify) –

function to be called before the returned GstBase.CollectData structure is freed

`lock` (bool) –

whether to lock this pad in usual waiting state

Returns (GstBase.CollectData) –

a new GstBase.CollectData to identify the new pad. Or None if wrong parameters are supplied.

#### gst_collect_pads_available

    guint
    gst_collect_pads_available (GstCollectPads * pads)

Query how much bytes can be read from each queued buffer. This means that the result of this call is the maximum number of bytes that can be read from each of the pads.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` –

the collectpads to query

Returns –

The maximum number of bytes queued on all pads. This function returns 0 if a pad has no queued buffer.

#### GstBase.CollectPads.prototype.available

    function GstBase.CollectPads.prototype.available(): {
        // javascript wrapper for 'gst_collect_pads_available'
    }

Query how much bytes can be read from each queued buffer. This means that the result of this call is the maximum number of bytes that can be read from each of the pads.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

Returns (Number) –

The maximum number of bytes queued on all pads. This function returns 0 if a pad has no queued buffer.

#### GstBase.CollectPads.available

    def GstBase.CollectPads.available (self):
        #python wrapper for 'gst_collect_pads_available'

Query how much bytes can be read from each queued buffer. This means that the result of this call is the maximum number of bytes that can be read from each of the pads.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

Returns (int) –

The maximum number of bytes queued on all pads. This function returns 0 if a pad has no queued buffer.

#### gst_collect_pads_clip_running_time

    GstFlowReturn
    gst_collect_pads_clip_running_time (GstCollectPads * pads,
                                        GstCollectData * cdata,
                                        GstBuffer * buf,
                                        GstBuffer ** outbuf,
                                        gpointer user_data)

Convenience clipping function that converts incoming buffer's timestamp to running time, or clips the buffer if outside configured segment.

Since 1.6, this clipping function also sets the DTS parameter of the GstCollectData structure. This version of the running time DTS can be negative. G_MININT64 is used to indicate invalid value.

Parameters:

`pads` –

the collectpads to use

`cdata` –

collect data of corresponding pad

`buf` –

buffer being clipped

`outbuf` ( [allow-none][out]) –

output buffer with running time, or NULL if clipped

`user_data` –

user data (unused)

Returns –
No description available

#### GstBase.CollectPads.prototype.clip_running_time

    function GstBase.CollectPads.prototype.clip_running_time(cdata: GstBase.CollectData, buf: Gst.Buffer, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_clip_running_time'
    }

Convenience clipping function that converts incoming buffer's timestamp to running time, or clips the buffer if outside configured segment.

Since 1.6, this clipping function also sets the DTS parameter of the GstCollectData structure. This version of the running time DTS can be negative. G_MININT64 is used to indicate invalid value.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`cdata` (GstBase.CollectData) –

collect data of corresponding pad

`buf` (Gst.Buffer) –

buffer being clipped

`user_data` (Object) –

user data (unused)

Returns a tuple made of:

(Gst.FlowReturn ) –
No description available
`outbuf` (Gst.Buffer ) –
No description available

#### GstBase.CollectPads.clip_running_time

    def GstBase.CollectPads.clip_running_time (self, cdata, buf, user_data):
        #python wrapper for 'gst_collect_pads_clip_running_time'

Convenience clipping function that converts incoming buffer's timestamp to running time, or clips the buffer if outside configured segment.

Since 1.6, this clipping function also sets the DTS parameter of the GstCollectData structure. This version of the running time DTS can be negative. G_MININT64 is used to indicate invalid value.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`cdata` (GstBase.CollectData) –

collect data of corresponding pad

`buf` (Gst.Buffer) –

buffer being clipped

`user_data` (object) –

user data (unused)

Returns a tuple made of:

(Gst.FlowReturn ) –
No description available
`outbuf` (Gst.Buffer ) –
No description available

#### gst_collect_pads_event_default

    gboolean
    gst_collect_pads_event_default (GstCollectPads * pads,
                                    GstCollectData * data,
                                    GstEvent * event,
                                    gboolean discard)

Default GstCollectPads event handling that elements should always chain up to to ensure proper operation. Element might however indicate event should not be forwarded downstream.

Parameters:

`pads` –

the collectpads to use

`data` –

collect data of corresponding pad

`event` –

event being processed

`discard` –

process but do not send event downstream

Returns –
No description available

#### GstBase.CollectPads.prototype.event_default

    function GstBase.CollectPads.prototype.event_default(data: GstBase.CollectData, event: Gst.Event, discard: Number): {
        // javascript wrapper for 'gst_collect_pads_event_default'
    }

Default GstBase.CollectPads event handling that elements should always chain up to to ensure proper operation. Element might however indicate event should not be forwarded downstream.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`data` (GstBase.CollectData) –

collect data of corresponding pad

`event` (Gst.Event) –

event being processed

`discard` (Number) –

process but do not send event downstream

Returns (Number) –
No description available

#### GstBase.CollectPads.event_default

    def GstBase.CollectPads.event_default (self, data, event, discard):
        #python wrapper for 'gst_collect_pads_event_default'

Default GstBase.CollectPads event handling that elements should always chain up to to ensure proper operation. Element might however indicate event should not be forwarded downstream.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`data` (GstBase.CollectData) –

collect data of corresponding pad

`event` (Gst.Event) –

event being processed

`discard` (bool) –

process but do not send event downstream

Returns (bool) –
No description available

#### gst_collect_pads_flush

    guint
    gst_collect_pads_flush (GstCollectPads * pads,
                            GstCollectData * data,
                            guint size)

Flush size bytes from the pad data.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` –

the collectpads to query

`data` –

the data to use

`size` –

the number of bytes to flush

Returns –

The number of bytes flushed This can be less than size and is 0 if the pad was end-of-stream.

#### GstBase.CollectPads.prototype.flush

    function GstBase.CollectPads.prototype.flush(data: GstBase.CollectData, size: Number): {
        // javascript wrapper for 'gst_collect_pads_flush'
    }

Flush size bytes from the pad data.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

`data` (GstBase.CollectData) –

the data to use

`size` (Number) –

the number of bytes to flush

Returns (Number) –

The number of bytes flushed This can be less than size and is 0 if the pad was end-of-stream.

#### GstBase.CollectPads.flush

    def GstBase.CollectPads.flush (self, data, size):
        #python wrapper for 'gst_collect_pads_flush'

Flush size bytes from the pad data.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

`data` (GstBase.CollectData) –

the data to use

`size` (int) –

the number of bytes to flush

Returns (int) –

The number of bytes flushed This can be less than size and is 0 if the pad was end-of-stream.

#### gst_collect_pads_peek

    GstBuffer *
    gst_collect_pads_peek (GstCollectPads * pads,
                           GstCollectData * data)

Peek at the buffer currently queued in data. This function should be called with the pads STREAM_LOCK held, such as in the callback handler.

MT safe.

Parameters:

`pads` –

the collectpads to peek

`data` –

the data to use

Returns ( [transfer: full][nullable]) –

The buffer in data or NULL if no buffer is queued. should unref the buffer after usage.

#### GstBase.CollectPads.prototype.peek

    function GstBase.CollectPads.prototype.peek(data: GstBase.CollectData): {
        // javascript wrapper for 'gst_collect_pads_peek'
    }

Peek at the buffer currently queued in data. This function should be called with the pads STREAM_LOCK held, such as in the callback handler.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to peek

`data` (GstBase.CollectData) –

the data to use

Returns (Gst.Buffer) –

The buffer in data or null if no buffer is queued. should unref the buffer after usage.

#### GstBase.CollectPads.peek

    def GstBase.CollectPads.peek (self, data):
        #python wrapper for 'gst_collect_pads_peek'

Peek at the buffer currently queued in data. This function should be called with the pads STREAM_LOCK held, such as in the callback handler.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to peek

`data` (GstBase.CollectData) –

the data to use

Returns (Gst.Buffer) –

The buffer in data or None if no buffer is queued. should unref the buffer after usage.

#### gst_collect_pads_pop

    GstBuffer *
    gst_collect_pads_pop (GstCollectPads * pads,
                          GstCollectData * data)

Pop the buffer currently queued in data. This function should be called with the pads STREAM_LOCK held, such as in the callback handler.

MT safe.

Parameters:

`pads` –

the collectpads to pop

`data` –

the data to use

Returns ( [transfer: full][nullable]) –

The buffer in data or NULL if no buffer was queued. You should unref the buffer after usage.

#### GstBase.CollectPads.prototype.pop

    function GstBase.CollectPads.prototype.pop(data: GstBase.CollectData): {
        // javascript wrapper for 'gst_collect_pads_pop'
    }

Pop the buffer currently queued in data. This function should be called with the pads STREAM_LOCK held, such as in the callback handler.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to pop

`data` (GstBase.CollectData) –

the data to use

Returns (Gst.Buffer) –

The buffer in data or null if no buffer was queued. You should unref the buffer after usage.

#### GstBase.CollectPads.pop

    def GstBase.CollectPads.pop (self, data):
        #python wrapper for 'gst_collect_pads_pop'

Pop the buffer currently queued in data. This function should be called with the pads STREAM_LOCK held, such as in the callback handler.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to pop

`data` (GstBase.CollectData) –

the data to use

Returns (Gst.Buffer) –

The buffer in data or None if no buffer was queued. You should unref the buffer after usage.

#### gst_collect_pads_query_default

    gboolean
    gst_collect_pads_query_default (GstCollectPads * pads,
                                    GstCollectData * data,
                                    GstQuery * query,
                                    gboolean discard)

Default GstCollectPads query handling that elements should always chain up to to ensure proper operation. Element might however indicate query should not be forwarded downstream.

Parameters:

`pads` –

the collectpads to use

`data` –

collect data of corresponding pad

`query` –

query being processed

`discard` –

process but do not send event downstream

Returns –
No description available

#### GstBase.CollectPads.prototype.query_default

    function GstBase.CollectPads.prototype.query_default(data: GstBase.CollectData, query: Gst.Query, discard: Number): {
        // javascript wrapper for 'gst_collect_pads_query_default'
    }

Default GstBase.CollectPads query handling that elements should always chain up to to ensure proper operation. Element might however indicate query should not be forwarded downstream.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`data` (GstBase.CollectData) –

collect data of corresponding pad

`query` (Gst.Query) –

query being processed

`discard` (Number) –

process but do not send event downstream

Returns (Number) –
No description available

#### GstBase.CollectPads.query_default

    def GstBase.CollectPads.query_default (self, data, query, discard):
        #python wrapper for 'gst_collect_pads_query_default'

Default GstBase.CollectPads query handling that elements should always chain up to to ensure proper operation. Element might however indicate query should not be forwarded downstream.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`data` (GstBase.CollectData) –

collect data of corresponding pad

`query` (Gst.Query) –

query being processed

`discard` (bool) –

process but do not send event downstream

Returns (bool) –
No description available

#### gst_collect_pads_read_buffer

    GstBuffer *
    gst_collect_pads_read_buffer (GstCollectPads * pads,
                                  GstCollectData * data,
                                  guint size)

Get a subbuffer of size bytes from the given pad data.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` –

the collectpads to query

`data` –

the data to use

`size` –

the number of bytes to read

Returns ( [transfer: full][nullable]) –

A sub buffer. The size of the buffer can be less that requested. A return of NULL signals that the pad is end-of-stream. Unref the buffer after use.

#### GstBase.CollectPads.prototype.read_buffer

    function GstBase.CollectPads.prototype.read_buffer(data: GstBase.CollectData, size: Number): {
        // javascript wrapper for 'gst_collect_pads_read_buffer'
    }

Get a subbuffer of size bytes from the given pad data.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

`data` (GstBase.CollectData) –

the data to use

`size` (Number) –

the number of bytes to read

Returns (Gst.Buffer) –

A sub buffer. The size of the buffer can be less that requested. A return of null signals that the pad is end-of-stream. Unref the buffer after use.

#### GstBase.CollectPads.read_buffer

    def GstBase.CollectPads.read_buffer (self, data, size):
        #python wrapper for 'gst_collect_pads_read_buffer'

Get a subbuffer of size bytes from the given pad data.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

`data` (GstBase.CollectData) –

the data to use

`size` (int) –

the number of bytes to read

Returns (Gst.Buffer) –

A sub buffer. The size of the buffer can be less that requested. A return of None signals that the pad is end-of-stream. Unref the buffer after use.

#### gst_collect_pads_remove_pad

    gboolean
    gst_collect_pads_remove_pad (GstCollectPads * pads,
                                 GstPad * pad)

Remove a pad from the collection of collect pads. This function will also free the GstCollectData and all the resources that were allocated with gst_collect_pads_add_pad.

The pad will be deactivated automatically when pads is stopped.

MT safe.

Parameters:

`pads` –

the collectpads to use

`pad` ( [transfer: none]) –

the pad to remove

Returns –

TRUE if the pad could be removed.

#### GstBase.CollectPads.prototype.remove_pad

    function GstBase.CollectPads.prototype.remove_pad(pad: Gst.Pad): {
        // javascript wrapper for 'gst_collect_pads_remove_pad'
    }

Remove a pad from the collection of collect pads. This function will also free the GstBase.CollectData and all the resources that were allocated with GstBase.CollectPads.prototype.add_pad.

The pad will be deactivated automatically when pads is stopped.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`pad` (Gst.Pad) –

the pad to remove

Returns (Number) –

true if the pad could be removed.

#### GstBase.CollectPads.remove_pad

    def GstBase.CollectPads.remove_pad (self, pad):
        #python wrapper for 'gst_collect_pads_remove_pad'

Remove a pad from the collection of collect pads. This function will also free the GstBase.CollectData and all the resources that were allocated with GstBase.CollectPads.add_pad.

The pad will be deactivated automatically when pads is stopped.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`pad` (Gst.Pad) –

the pad to remove

Returns (bool) –

True if the pad could be removed.

#### gst_collect_pads_set_buffer_function

    gst_collect_pads_set_buffer_function (GstCollectPads * pads,
                                          GstCollectPadsBufferFunction func,
                                          gpointer user_data)

Set the callback function and user data that will be called with the oldest buffer when all pads have been collected, or NULL on EOS. If a buffer is passed, the callback owns a reference and must unref it.

MT safe.

Parameters:

`pads` –

the collectpads to use

`func` ( [scope call][closure]) –

the function to set

`user_data` –

user data passed to the function

#### GstBase.CollectPads.prototype.set_buffer_function

    function GstBase.CollectPads.prototype.set_buffer_function(func: GstBase.CollectPadsBufferFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_buffer_function'
    }

Set the callback function and user data that will be called with the oldest buffer when all pads have been collected, or null on EOS. If a buffer is passed, the callback owns a reference and must unref it.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsBufferFunction) –

the function to set

`user_data` (Object) –

user data passed to the function

#### GstBase.CollectPads.set_buffer_function

    def GstBase.CollectPads.set_buffer_function (self, func, *user_data):
        #python wrapper for 'gst_collect_pads_set_buffer_function'

Set the callback function and user data that will be called with the oldest buffer when all pads have been collected, or None on EOS. If a buffer is passed, the callback owns a reference and must unref it.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsBufferFunction) –

the function to set

`user_data` (variadic) –

user data passed to the function

#### gst_collect_pads_set_clip_function

    gst_collect_pads_set_clip_function (GstCollectPads * pads,
                                        GstCollectPadsClipFunction clipfunc,
                                        gpointer user_data)

Install a clipping function that is called right after a buffer is received on a pad managed by pads. See GstCollectPadsClipFunction for more info.

Parameters:

`pads` –

the collectpads to use

`clipfunc` ( [scope call]) –

clip function to install

`user_data` –

user data to pass to clip_func

#### GstBase.CollectPads.prototype.set_clip_function

    function GstBase.CollectPads.prototype.set_clip_function(clipfunc: GstBase.CollectPadsClipFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_clip_function'
    }

Install a clipping function that is called right after a buffer is received on a pad managed by pads. See GstBase.CollectPadsClipFunction for more info.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`clipfunc` (GstBase.CollectPadsClipFunction) –

clip function to install

`user_data` (Object) –

user data to pass to clip_func

#### GstBase.CollectPads.set_clip_function

    def GstBase.CollectPads.set_clip_function (self, clipfunc, *user_data):
        #python wrapper for 'gst_collect_pads_set_clip_function'

Install a clipping function that is called right after a buffer is received on a pad managed by pads. See GstBase.CollectPadsClipFunction for more info.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`clipfunc` (GstBase.CollectPadsClipFunction) –

clip function to install

`user_data` (variadic) –

user data to pass to clip_func

#### gst_collect_pads_set_compare_function

    gst_collect_pads_set_compare_function (GstCollectPads * pads,
                                           GstCollectPadsCompareFunction func,
                                           gpointer user_data)

Set the timestamp comparison function.

MT safe.

Parameters:

`pads` –

the pads to use

`func` ( [scope call][closure]) –

the function to set

`user_data` –

user data passed to the function

#### GstBase.CollectPads.prototype.set_compare_function

    function GstBase.CollectPads.prototype.set_compare_function(func: GstBase.CollectPadsCompareFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_compare_function'
    }

Set the timestamp comparison function.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the pads to use

`func` (GstBase.CollectPadsCompareFunction) –

the function to set

`user_data` (Object) –

user data passed to the function

#### GstBase.CollectPads.set_compare_function

    def GstBase.CollectPads.set_compare_function (self, func, *user_data):
        #python wrapper for 'gst_collect_pads_set_compare_function'

Set the timestamp comparison function.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the pads to use

`func` (GstBase.CollectPadsCompareFunction) –

the function to set

`user_data` (variadic) –

user data passed to the function

#### gst_collect_pads_set_event_function

    gst_collect_pads_set_event_function (GstCollectPads * pads,
                                         GstCollectPadsEventFunction func,
                                         gpointer user_data)

Set the event callback function and user data that will be called when collectpads has received an event originating from one of the collected pads. If the event being processed is a serialized one, this callback is called with pads STREAM_LOCK held, otherwise not. As this lock should be held when calling a number of CollectPads functions, it should be acquired if so (unusually) needed.

MT safe.

Parameters:

`pads` –

the collectpads to use

`func` ( [scope call]) –

the function to set

`user_data` –

user data passed to the function

#### GstBase.CollectPads.prototype.set_event_function

    function GstBase.CollectPads.prototype.set_event_function(func: GstBase.CollectPadsEventFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_event_function'
    }

Set the event callback function and user data that will be called when collectpads has received an event originating from one of the collected pads. If the event being processed is a serialized one, this callback is called with pads STREAM_LOCK held, otherwise not. As this lock should be held when calling a number of CollectPads functions, it should be acquired if so (unusually) needed.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsEventFunction) –

the function to set

`user_data` (Object) –

user data passed to the function

#### GstBase.CollectPads.set_event_function

    def GstBase.CollectPads.set_event_function (self, func, *user_data):
        #python wrapper for 'gst_collect_pads_set_event_function'

Set the event callback function and user data that will be called when collectpads has received an event originating from one of the collected pads. If the event being processed is a serialized one, this callback is called with pads STREAM_LOCK held, otherwise not. As this lock should be held when calling a number of CollectPads functions, it should be acquired if so (unusually) needed.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsEventFunction) –

the function to set

`user_data` (variadic) –

user data passed to the function

#### gst_collect_pads_set_flush_function

    gst_collect_pads_set_flush_function (GstCollectPads * pads,
                                         GstCollectPadsFlushFunction func,
                                         gpointer user_data)

Install a flush function that is called when the internal state of all pads should be flushed as part of flushing seek handling. See GstCollectPadsFlushFunction for more info.

Parameters:

`pads` –

the collectpads to use

`func` ( [scope call]) –

flush function to install

`user_data` –

user data to pass to func

Since : 1.4

#### GstBase.CollectPads.prototype.set_flush_function

    function GstBase.CollectPads.prototype.set_flush_function(func: GstBase.CollectPadsFlushFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_flush_function'
    }

Install a flush function that is called when the internal state of all pads should be flushed as part of flushing seek handling. See GstBase.CollectPadsFlushFunction for more info.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsFlushFunction) –

flush function to install

`user_data` (Object) –

user data to pass to func

Since : 1.4

#### GstBase.CollectPads.set_flush_function

    def GstBase.CollectPads.set_flush_function (self, func, *user_data):
        #python wrapper for 'gst_collect_pads_set_flush_function'

Install a flush function that is called when the internal state of all pads should be flushed as part of flushing seek handling. See GstBase.CollectPadsFlushFunction for more info.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsFlushFunction) –

flush function to install

`user_data` (variadic) –

user data to pass to func

Since : 1.4

#### gst_collect_pads_set_flushing

    gst_collect_pads_set_flushing (GstCollectPads * pads,
                                   gboolean flushing)

Change the flushing state of all the pads in the collection. No pad is able to accept anymore data when flushing is TRUE. Calling this function with flushing FALSE makes pads accept data again. Caller must ensure that downstream streaming (thread) is not blocked, e.g. by sending a FLUSH_START downstream.

MT safe.

Parameters:

`pads` –

the collectpads to use

`flushing` –

desired state of the pads

#### GstBase.CollectPads.prototype.set_flushing

    function GstBase.CollectPads.prototype.set_flushing(flushing: Number): {
        // javascript wrapper for 'gst_collect_pads_set_flushing'
    }

Change the flushing state of all the pads in the collection. No pad is able to accept anymore data when flushing is true. Calling this function with flushing false makes pads accept data again. Caller must ensure that downstream streaming (thread) is not blocked, e.g. by sending a FLUSH_START downstream.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`flushing` (Number) –

desired state of the pads

#### GstBase.CollectPads.set_flushing

    def GstBase.CollectPads.set_flushing (self, flushing):
        #python wrapper for 'gst_collect_pads_set_flushing'

Change the flushing state of all the pads in the collection. No pad is able to accept anymore data when flushing is True. Calling this function with flushing False makes pads accept data again. Caller must ensure that downstream streaming (thread) is not blocked, e.g. by sending a FLUSH_START downstream.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`flushing` (bool) –

desired state of the pads

#### gst_collect_pads_set_function

    gst_collect_pads_set_function (GstCollectPads * pads,
                                   GstCollectPadsFunction func,
                                   gpointer user_data)

CollectPads provides a default collection algorithm that will determine the oldest buffer available on all of its pads, and then delegate to a configured callback. However, if circumstances are more complicated and/or more control is desired, this sets a callback that will be invoked instead when all the pads added to the collection have buffers queued. Evidently, this callback is not compatible with gst_collect_pads_set_buffer_function callback. If this callback is set, the former will be unset.

MT safe.

Parameters:

`pads` –

the collectpads to use

`func` ( [scope call]) –

the function to set

`user_data` –

user data passed to the function

#### GstBase.CollectPads.prototype.set_function

    function GstBase.CollectPads.prototype.set_function(func: GstBase.CollectPadsFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_function'
    }

CollectPads provides a default collection algorithm that will determine the oldest buffer available on all of its pads, and then delegate to a configured callback. However, if circumstances are more complicated and/or more control is desired, this sets a callback that will be invoked instead when all the pads added to the collection have buffers queued. Evidently, this callback is not compatible with GstBase.CollectPads.prototype.set_buffer_function callback. If this callback is set, the former will be unset.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsFunction) –

the function to set

`user_data` (Object) –

user data passed to the function

#### GstBase.CollectPads.set_function

    def GstBase.CollectPads.set_function (self, func, *user_data):
        #python wrapper for 'gst_collect_pads_set_function'

CollectPads provides a default collection algorithm that will determine the oldest buffer available on all of its pads, and then delegate to a configured callback. However, if circumstances are more complicated and/or more control is desired, this sets a callback that will be invoked instead when all the pads added to the collection have buffers queued. Evidently, this callback is not compatible with GstBase.CollectPads.set_buffer_function callback. If this callback is set, the former will be unset.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsFunction) –

the function to set

`user_data` (variadic) –

user data passed to the function

#### gst_collect_pads_set_query_function

    gst_collect_pads_set_query_function (GstCollectPads * pads,
                                         GstCollectPadsQueryFunction func,
                                         gpointer user_data)

Set the query callback function and user data that will be called after collectpads has received a query originating from one of the collected pads. If the query being processed is a serialized one, this callback is called with pads STREAM_LOCK held, otherwise not. As this lock should be held when calling a number of CollectPads functions, it should be acquired if so (unusually) needed.

MT safe.

Parameters:

`pads` –

the collectpads to use

`func` ( [scope call]) –

the function to set

`user_data` –

user data passed to the function

#### GstBase.CollectPads.prototype.set_query_function

    function GstBase.CollectPads.prototype.set_query_function(func: GstBase.CollectPadsQueryFunction, user_data: Object): {
        // javascript wrapper for 'gst_collect_pads_set_query_function'
    }

Set the query callback function and user data that will be called after collectpads has received a query originating from one of the collected pads. If the query being processed is a serialized one, this callback is called with pads STREAM_LOCK held, otherwise not. As this lock should be held when calling a number of CollectPads functions, it should be acquired if so (unusually) needed.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsQueryFunction) –

the function to set

`user_data` (Object) –

user data passed to the function

#### GstBase.CollectPads.set_query_function

    def GstBase.CollectPads.set_query_function (self, func, *user_data):
        #python wrapper for 'gst_collect_pads_set_query_function'

Set the query callback function and user data that will be called after collectpads has received a query originating from one of the collected pads. If the query being processed is a serialized one, this callback is called with pads STREAM_LOCK held, otherwise not. As this lock should be held when calling a number of CollectPads functions, it should be acquired if so (unusually) needed.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

`func` (GstBase.CollectPadsQueryFunction) –

the function to set

`user_data` (variadic) –

user data passed to the function

#### gst_collect_pads_set_waiting

    gst_collect_pads_set_waiting (GstCollectPads * pads,
                                  GstCollectData * data,
                                  gboolean waiting)

Sets a pad to waiting or non-waiting mode, if at least this pad has not been created with locked waiting state, in which case nothing happens.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` –

the collectpads

`data` –

the data to use

`waiting` –

boolean indicating whether this pad should operate in waiting or non-waiting mode

#### GstBase.CollectPads.prototype.set_waiting

    function GstBase.CollectPads.prototype.set_waiting(data: GstBase.CollectData, waiting: Number): {
        // javascript wrapper for 'gst_collect_pads_set_waiting'
    }

Sets a pad to waiting or non-waiting mode, if at least this pad has not been created with locked waiting state, in which case nothing happens.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads

`data` (GstBase.CollectData) –

the data to use

`waiting` (Number) –

boolean indicating whether this pad should operate in waiting or non-waiting mode

#### GstBase.CollectPads.set_waiting

    def GstBase.CollectPads.set_waiting (self, data, waiting):
        #python wrapper for 'gst_collect_pads_set_waiting'

Sets a pad to waiting or non-waiting mode, if at least this pad has not been created with locked waiting state, in which case nothing happens.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads

`data` (GstBase.CollectData) –

the data to use

`waiting` (bool) –

boolean indicating whether this pad should operate in waiting or non-waiting mode

#### gst_collect_pads_src_event_default

    gboolean
    gst_collect_pads_src_event_default (GstCollectPads * pads,
                                        GstPad * pad,
                                        GstEvent * event)

Default GstCollectPads event handling for the src pad of elements. Elements can chain up to this to let flushing seek event handling be done by GstCollectPads.

Parameters:

`pads` –

the GstCollectPads to use

`pad` –

src GstPad that received the event

`event` –

event being processed

Returns –
No description available

Since : 1.4

#### GstBase.CollectPads.prototype.src_event_default

    function GstBase.CollectPads.prototype.src_event_default(pad: Gst.Pad, event: Gst.Event): {
        // javascript wrapper for 'gst_collect_pads_src_event_default'
    }

Default GstBase.CollectPads event handling for the src pad of elements. Elements can chain up to this to let flushing seek event handling be done by GstBase.CollectPads.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads to use

`pad` (Gst.Pad) –

src Gst.Pad that received the event

`event` (Gst.Event) –

event being processed

Returns (Number) –
No description available

Since : 1.4

#### GstBase.CollectPads.src_event_default

    def GstBase.CollectPads.src_event_default (self, pad, event):
        #python wrapper for 'gst_collect_pads_src_event_default'

Default GstBase.CollectPads event handling for the src pad of elements. Elements can chain up to this to let flushing seek event handling be done by GstBase.CollectPads.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads to use

`pad` (Gst.Pad) –

src Gst.Pad that received the event

`event` (Gst.Event) –

event being processed

Returns (bool) –
No description available

Since : 1.4

#### gst_collect_pads_start

    gst_collect_pads_start (GstCollectPads * pads)

Starts the processing of data in the collect_pads.

MT safe.

Parameters:

`pads` –

the collectpads to use

#### GstBase.CollectPads.prototype.start

    function GstBase.CollectPads.prototype.start(): {
        // javascript wrapper for 'gst_collect_pads_start'
    }

Starts the processing of data in the collect_pads.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

#### GstBase.CollectPads.start

    def GstBase.CollectPads.start (self):
        #python wrapper for 'gst_collect_pads_start'

Starts the processing of data in the collect_pads.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

#### gst_collect_pads_stop

    gst_collect_pads_stop (GstCollectPads * pads)

Stops the processing of data in the collect_pads. this function will also unblock any blocking operations.

MT safe.

Parameters:

`pads` –

the collectpads to use

#### GstBase.CollectPads.prototype.stop

    function GstBase.CollectPads.prototype.stop(): {
        // javascript wrapper for 'gst_collect_pads_stop'
    }

Stops the processing of data in the collect_pads. this function will also unblock any blocking operations.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

#### GstBase.CollectPads.stop

    def GstBase.CollectPads.stop (self):
        #python wrapper for 'gst_collect_pads_stop'

Stops the processing of data in the collect_pads. this function will also unblock any blocking operations.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to use

#### gst_collect_pads_take_buffer

    GstBuffer *
    gst_collect_pads_take_buffer (GstCollectPads * pads,
                                  GstCollectData * data,
                                  guint size)

Get a subbuffer of size bytes from the given pad data. Flushes the amount of read bytes.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` –

the collectpads to query

`data` –

the data to use

`size` –

the number of bytes to read

Returns ( [transfer: full][nullable]) –

A sub buffer. The size of the buffer can be less that requested. A return of NULL signals that the pad is end-of-stream. Unref the buffer after use.

#### GstBase.CollectPads.prototype.take_buffer

    function GstBase.CollectPads.prototype.take_buffer(data: GstBase.CollectData, size: Number): {
        // javascript wrapper for 'gst_collect_pads_take_buffer'
    }

Get a subbuffer of size bytes from the given pad data. Flushes the amount of read bytes.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

`data` (GstBase.CollectData) –

the data to use

`size` (Number) –

the number of bytes to read

Returns (Gst.Buffer) –

A sub buffer. The size of the buffer can be less that requested. A return of null signals that the pad is end-of-stream. Unref the buffer after use.

#### GstBase.CollectPads.take_buffer

    def GstBase.CollectPads.take_buffer (self, data, size):
        #python wrapper for 'gst_collect_pads_take_buffer'

Get a subbuffer of size bytes from the given pad data. Flushes the amount of read bytes.

This function should be called with pads STREAM_LOCK held, such as in the callback.

MT safe.

Parameters:

`pads` (GstBase.CollectPads) –

the collectpads to query

`data` (GstBase.CollectData) –

the data to use

`size` (int) –

the number of bytes to read

Returns (Gst.Buffer) –

A sub buffer. The size of the buffer can be less that requested. A return of None signals that the pad is end-of-stream. Unref the buffer after use.

## Function Macros

### GST_COLLECT_PADS_DTS

    #define GST_COLLECT_PADS_DTS(data)                   (((GstCollectData *) data)->ABI.abi.dts)

Returns the DTS that has been converted to running time when using gst_collect_pads_clip_running_time. Unlike the value saved into the buffer, this value is of type gint64 and may be negative. This allow properly handling streams with frame reordering where the first DTS may be negative. If the initial DTS was not set, this value will be set to G_MININT64.

Parameters:

`data` –

A GstCollectData.

Since : 1.6

### GST_COLLECT_PADS_DTS_IS_VALID

    #define GST_COLLECT_PADS_DTS_IS_VALID(data)          (GST_CLOCK_STIME_IS_VALID (GST_COLLECT_PADS_DTS (data)))

Check if running DTS value store is valid.

Parameters:

`data` –

A GstCollectData.

Since : 1.6

### GST_COLLECT_PADS_GET_STREAM_LOCK

    #define GST_COLLECT_PADS_GET_STREAM_LOCK(pads) (&((GstCollectPads *)pads)->stream_lock)

Get the stream lock of pads. The stream lock is used to coordinate and serialize execution among the various streams being collected, and in protecting the resources used to accomplish this.

Parameters:

`pads` –

a GstCollectPads

### GST_COLLECT_PADS_STATE

    #define GST_COLLECT_PADS_STATE(data)                 (((GstCollectData *) data)->state)

A flags word containing GstCollectPadsStateFlags flags set on this collected pad.

Parameters:

`data` –

a GstCollectData.

### GST_COLLECT_PADS_STATE_IS_SET

    #define GST_COLLECT_PADS_STATE_IS_SET(data,flag)     !!(GST_COLLECT_PADS_STATE (data) & flag)

Gives the status of a specific flag on a collected pad.

Parameters:

`data` –

a GstCollectData.

`flag` –

the GstCollectPadsStateFlags to check.

### GST_COLLECT_PADS_STATE_SET

    #define GST_COLLECT_PADS_STATE_SET(data,flag)        (GST_COLLECT_PADS_STATE (data) |= flag)

Sets a state flag on a collected pad.

Parameters:

`data` –

a GstCollectData.

`flag` –

the GstCollectPadsStateFlags to set.

### GST_COLLECT_PADS_STATE_UNSET

    #define GST_COLLECT_PADS_STATE_UNSET(data,flag)      (GST_COLLECT_PADS_STATE (data) &= ~(flag))

Clears a state flag on a collected pad.

Parameters:

`data` –

a GstCollectData.

`flag` –

the GstCollectPadsStateFlags to clear.

### GST_COLLECT_PADS_STREAM_LOCK

    #define GST_COLLECT_PADS_STREAM_LOCK(pads)     g_rec_mutex_lock(GST_COLLECT_PADS_GET_STREAM_LOCK (pads))

Lock the stream lock of pads.

Parameters:

`pads` –

a GstCollectPads

### GST_COLLECT_PADS_STREAM_UNLOCK

    #define GST_COLLECT_PADS_STREAM_UNLOCK(pads)   g_rec_mutex_unlock(GST_COLLECT_PADS_GET_STREAM_LOCK (pads))

Unlock the stream lock of pads.

Parameters:

`pads` –

a GstCollectPads

## Enumerations

### GstCollectPadsStateFlags

##### Members

`GST_COLLECT_PADS_STATE_EOS` (1) –

Set if collectdata's pad is EOS.

`GST_COLLECT_PADS_STATE_FLUSHING` (2) –

Set if collectdata's pad is flushing.

`GST_COLLECT_PADS_STATE_NEW_SEGMENT` (4) –

Set if collectdata's pad received a new_segment event.

`GST_COLLECT_PADS_STATE_WAITING` (8) –

Set if collectdata's pad must be waited for when collecting.

`GST_COLLECT_PADS_STATE_LOCKED` (16) –

Set collectdata's pad WAITING state must not be changed. GstCollectPadsStateFlags indicate private state of a collectdata('s pad).

### GstBase.CollectPadsStateFlags

##### Members

`GstBase.CollectPadsStateFlags.EOS` (1) –

Set if collectdata's pad is EOS.

`GstBase.CollectPadsStateFlags.FLUSHING` (2) –

Set if collectdata's pad is flushing.

`GstBase.CollectPadsStateFlags.NEW_SEGMENT` (4) –

Set if collectdata's pad received a new_segment event.

`GstBase.CollectPadsStateFlags.WAITING` (8) –

Set if collectdata's pad must be waited for when collecting.

`GstBase.CollectPadsStateFlags.LOCKED` (16) –

Set collectdata's pad WAITING state must not be changed. GstBase.CollectPadsStateFlags indicate private state of a collectdata('s pad).

### GstBase.CollectPadsStateFlags

##### Members

`GstBase.CollectPadsStateFlags.EOS` (1) –

Set if collectdata's pad is EOS.

`GstBase.CollectPadsStateFlags.FLUSHING` (2) –

Set if collectdata's pad is flushing.

`GstBase.CollectPadsStateFlags.NEW_SEGMENT` (4) –

Set if collectdata's pad received a new_segment event.

`GstBase.CollectPadsStateFlags.WAITING` (8) –

Set if collectdata's pad must be waited for when collecting.

`GstBase.CollectPadsStateFlags.LOCKED` (16) –

Set collectdata's pad WAITING state must not be changed. GstBase.CollectPadsStateFlags indicate private state of a collectdata('s pad).

## Callbacks

### GstCollectDataDestroyNotify

    (*GstCollectDataDestroyNotify) (GstCollectData * data)

A function that will be called when the GstCollectData will be freed. It is passed the pointer to the structure and should free any custom memory and resources allocated for it.

Parameters:

`data` –

the GstCollectData that will be freed

### GstBase.CollectDataDestroyNotify

    function GstBase.CollectDataDestroyNotify(data: GstBase.CollectData): {
        // javascript wrapper for 'GstCollectDataDestroyNotify'
    }

A function that will be called when the GstBase.CollectData will be freed. It is passed the pointer to the structure and should free any custom memory and resources allocated for it.

Parameters:

`data` (GstBase.CollectData) –

the GstBase.CollectData that will be freed

### GstBase.CollectDataDestroyNotify

    def GstBase.CollectDataDestroyNotify (data):
        #python wrapper for 'GstCollectDataDestroyNotify'

A function that will be called when the GstBase.CollectData will be freed. It is passed the pointer to the structure and should free any custom memory and resources allocated for it.

Parameters:

`data` (GstBase.CollectData) –

the GstBase.CollectData that will be freed

### GstCollectPadsBufferFunction

    GstFlowReturn
    (*GstCollectPadsBufferFunction) (GstCollectPads * pads,
                                     GstCollectData * data,
                                     GstBuffer * buffer,
                                     gpointer user_data)

A function that will be called when a (considered oldest) buffer can be muxed. If all pads have reached EOS, this function is called with NULL buffer and NULL data.

Parameters:

`pads` –

the GstCollectPads that triggered the callback

`data` –

the GstCollectData of pad that has received the buffer

`buffer` ( [transfer: full]) –

the GstBuffer

`user_data` –

user data passed to gst_collect_pads_set_buffer_function

Returns –

GST_FLOW_OK for success

### GstBase.CollectPadsBufferFunction

    function GstBase.CollectPadsBufferFunction(pads: GstBase.CollectPads, data: GstBase.CollectData, buffer: Gst.Buffer, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsBufferFunction'
    }

A function that will be called when a (considered oldest) buffer can be muxed. If all pads have reached EOS, this function is called with null buffer and null data.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`data` (GstBase.CollectData) –

the GstBase.CollectData of pad that has received the buffer

`buffer` (Gst.Buffer) –

the Gst.Buffer

`user_data` (Object) –

user data passed to GstBase.CollectPads.prototype.set_buffer_function

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### GstBase.CollectPadsBufferFunction

    def GstBase.CollectPadsBufferFunction (pads, data, buffer, *user_data):
        #python wrapper for 'GstCollectPadsBufferFunction'

A function that will be called when a (considered oldest) buffer can be muxed. If all pads have reached EOS, this function is called with None buffer and None data.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`data` (GstBase.CollectData) –

the GstBase.CollectData of pad that has received the buffer

`buffer` (Gst.Buffer) –

the Gst.Buffer

`user_data` (variadic) –

user data passed to GstBase.CollectPads.set_buffer_function

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### GstCollectPadsClipFunction

    GstFlowReturn
    (*GstCollectPadsClipFunction) (GstCollectPads * pads,
                                   GstCollectData * data,
                                   GstBuffer * inbuffer,
                                   GstBuffer ** outbuffer,
                                   gpointer user_data)

A function that will be called when inbuffer is received on the pad managed by data in the collectpad object pads.

The function should use the segment of data and the negotiated media type on the pad to perform clipping of inbuffer.

This function takes ownership of inbuffer and should output a buffer in outbuffer or return NULL in outbuffer if the buffer should be dropped.

Parameters:

`pads` –

a GstCollectPads

`data` –

a GstCollectData

`inbuffer` ( [transfer: full]) –

the input GstBuffer

`outbuffer` ( [out]) –

the output GstBuffer

`user_data` –

user data

Returns –

a GstFlowReturn that corresponds to the result of clipping.

### GstBase.CollectPadsClipFunction

    function GstBase.CollectPadsClipFunction(pads: GstBase.CollectPads, data: GstBase.CollectData, inbuffer: Gst.Buffer, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsClipFunction'
    }

A function that will be called when inbuffer is received on the pad managed by data in the collectpad object pads.

The function should use the segment of data and the negotiated media type on the pad to perform clipping of inbuffer.

This function takes ownership of inbuffer and should output a buffer in outbuffer or return null in outbuffer if the buffer should be dropped.

Parameters:

`pads` (GstBase.CollectPads) –

a GstBase.CollectPads

`data` (GstBase.CollectData) –

a GstBase.CollectData

`inbuffer` (Gst.Buffer) –

the input Gst.Buffer

`user_data` (Object) –

user data

Returns a tuple made of:

(Gst.FlowReturn ) –

a Gst.FlowReturn that corresponds to the result of clipping.

`outbuffer` (Gst.Buffer ) –

a Gst.FlowReturn that corresponds to the result of clipping.

### GstBase.CollectPadsClipFunction

    def GstBase.CollectPadsClipFunction (pads, data, inbuffer, *user_data):
        #python wrapper for 'GstCollectPadsClipFunction'

A function that will be called when inbuffer is received on the pad managed by data in the collectpad object pads.

The function should use the segment of data and the negotiated media type on the pad to perform clipping of inbuffer.

This function takes ownership of inbuffer and should output a buffer in outbuffer or return None in outbuffer if the buffer should be dropped.

Parameters:

`pads` (GstBase.CollectPads) –

a GstBase.CollectPads

`data` (GstBase.CollectData) –

a GstBase.CollectData

`inbuffer` (Gst.Buffer) –

the input Gst.Buffer

`user_data` (variadic) –

user data

Returns a tuple made of:

(Gst.FlowReturn ) –

a Gst.FlowReturn that corresponds to the result of clipping.

`outbuffer` (Gst.Buffer ) –

a Gst.FlowReturn that corresponds to the result of clipping.

### GstCollectPadsCompareFunction

    gint
    (*GstCollectPadsCompareFunction) (GstCollectPads * pads,
                                      GstCollectData * data1,
                                      GstClockTime timestamp1,
                                      GstCollectData * data2,
                                      GstClockTime timestamp2,
                                      gpointer user_data)

A function for comparing two timestamps of buffers or newsegments collected on one pad.

Parameters:

`pads` –

the GstCollectPads that is comparing the timestamps

`data1` –

the first GstCollectData

`timestamp1` –

the first timestamp

`data2` –

the second GstCollectData

`timestamp2` –

the second timestamp

`user_data` –

user data passed to gst_collect_pads_set_compare_function

Returns –

Integer less than zero when first timestamp is deemed older than the second one. Zero if the timestamps are deemed equally old. Integer greater than zero when second timestamp is deemed older than the first one.

### GstBase.CollectPadsCompareFunction

    function GstBase.CollectPadsCompareFunction(pads: GstBase.CollectPads, data1: GstBase.CollectData, timestamp1: Number, data2: GstBase.CollectData, timestamp2: Number, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsCompareFunction'
    }

A function for comparing two timestamps of buffers or newsegments collected on one pad.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that is comparing the timestamps

`data1` (GstBase.CollectData) –

the first GstBase.CollectData

`timestamp1` (Number) –

the first timestamp

`data2` (GstBase.CollectData) –

the second GstBase.CollectData

`timestamp2` (Number) –

the second timestamp

`user_data` (Object) –

user data passed to GstBase.CollectPads.prototype.set_compare_function

Returns (Number) –

Integer less than zero when first timestamp is deemed older than the second one. Zero if the timestamps are deemed equally old. Integer greater than zero when second timestamp is deemed older than the first one.

### GstBase.CollectPadsCompareFunction

    def GstBase.CollectPadsCompareFunction (pads, data1, timestamp1, data2, timestamp2, *user_data):
        #python wrapper for 'GstCollectPadsCompareFunction'

A function for comparing two timestamps of buffers or newsegments collected on one pad.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that is comparing the timestamps

`data1` (GstBase.CollectData) –

the first GstBase.CollectData

`timestamp1` (int) –

the first timestamp

`data2` (GstBase.CollectData) –

the second GstBase.CollectData

`timestamp2` (int) –

the second timestamp

`user_data` (variadic) –

user data passed to GstBase.CollectPads.set_compare_function

Returns (int) –

Integer less than zero when first timestamp is deemed older than the second one. Zero if the timestamps are deemed equally old. Integer greater than zero when second timestamp is deemed older than the first one.

### GstCollectPadsEventFunction

    gboolean
    (*GstCollectPadsEventFunction) (GstCollectPads * pads,
                                    GstCollectData * pad,
                                    GstEvent * event,
                                    gpointer user_data)

A function that will be called while processing an event. It takes ownership of the event and is responsible for chaining up (to gst_collect_pads_event_default) or dropping events (such typical cases being handled by the default handler).

Parameters:

`pads` –

the GstCollectPads that triggered the callback

`pad` –

the GstPad that received an event

`event` –

the GstEvent received

`user_data` –

user data passed to gst_collect_pads_set_event_function

Returns –

TRUE if the pad could handle the event

### GstBase.CollectPadsEventFunction

    function GstBase.CollectPadsEventFunction(pads: GstBase.CollectPads, pad: GstBase.CollectData, event: Gst.Event, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsEventFunction'
    }

A function that will be called while processing an event. It takes ownership of the event and is responsible for chaining up (to GstBase.CollectPads.prototype.event_default) or dropping events (such typical cases being handled by the default handler).

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`pad` (GstBase.CollectData) –

the Gst.Pad that received an event

`event` (Gst.Event) –

the Gst.Event received

`user_data` (Object) –

user data passed to GstBase.CollectPads.prototype.set_event_function

Returns (Number) –

true if the pad could handle the event

### GstBase.CollectPadsEventFunction

    def GstBase.CollectPadsEventFunction (pads, pad, event, *user_data):
        #python wrapper for 'GstCollectPadsEventFunction'

A function that will be called while processing an event. It takes ownership of the event and is responsible for chaining up (to GstBase.CollectPads.event_default) or dropping events (such typical cases being handled by the default handler).

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`pad` (GstBase.CollectData) –

the Gst.Pad that received an event

`event` (Gst.Event) –

the Gst.Event received

`user_data` (variadic) –

user data passed to GstBase.CollectPads.set_event_function

Returns (bool) –

True if the pad could handle the event

### GstCollectPadsFlushFunction

    (*GstCollectPadsFlushFunction) (GstCollectPads * pads,
                                    gpointer user_data)

A function that will be called while processing a flushing seek event.

The function should flush any internal state of the element and the state of all the pads. It should clear only the state not directly managed by the pads object. It is therefore not necessary to call gst_collect_pads_set_flushing nor gst_collect_pads_clear from this function.

Parameters:

`pads` –

a GstCollectPads

`user_data` –

user data

Since : 1.4

### GstBase.CollectPadsFlushFunction

    function GstBase.CollectPadsFlushFunction(pads: GstBase.CollectPads, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsFlushFunction'
    }

A function that will be called while processing a flushing seek event.

The function should flush any internal state of the element and the state of all the pads. It should clear only the state not directly managed by the pads object. It is therefore not necessary to call gst_collect_pads_set_flushing nor gst_collect_pads_clear from this function.

Parameters:

`pads` (GstBase.CollectPads) –

a GstBase.CollectPads

`user_data` (Object) –

user data

Since : 1.4

### GstBase.CollectPadsFlushFunction

    def GstBase.CollectPadsFlushFunction (pads, *user_data):
        #python wrapper for 'GstCollectPadsFlushFunction'

A function that will be called while processing a flushing seek event.

The function should flush any internal state of the element and the state of all the pads. It should clear only the state not directly managed by the pads object. It is therefore not necessary to call gst_collect_pads_set_flushing nor gst_collect_pads_clear from this function.

Parameters:

`pads` (GstBase.CollectPads) –

a GstBase.CollectPads

`user_data` (variadic) –

user data

Since : 1.4

### GstCollectPadsFunction

    GstFlowReturn
    (*GstCollectPadsFunction) (GstCollectPads * pads,
                               gpointer user_data)

A function that will be called when all pads have received data.

Parameters:

`pads` –

the GstCollectPads that triggered the callback

`user_data` –

user data passed to gst_collect_pads_set_function

Returns –

GST_FLOW_OK for success

### GstBase.CollectPadsFunction

    function GstBase.CollectPadsFunction(pads: GstBase.CollectPads, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsFunction'
    }

A function that will be called when all pads have received data.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`user_data` (Object) –

user data passed to GstBase.CollectPads.prototype.set_function

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### GstBase.CollectPadsFunction

    def GstBase.CollectPadsFunction (pads, *user_data):
        #python wrapper for 'GstCollectPadsFunction'

A function that will be called when all pads have received data.

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`user_data` (variadic) –

user data passed to GstBase.CollectPads.set_function

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### GstCollectPadsQueryFunction

    gboolean
    (*GstCollectPadsQueryFunction) (GstCollectPads * pads,
                                    GstCollectData * pad,
                                    GstQuery * query,
                                    gpointer user_data)

A function that will be called while processing a query. It takes ownership of the query and is responsible for chaining up (to events downstream (with gst_pad_event_default).

Parameters:

`pads` –

the GstCollectPads that triggered the callback

`pad` –

the GstPad that received an event

`query` –

the GstEvent received

`user_data` –

user data passed to gst_collect_pads_set_query_function

Returns –

TRUE if the pad could handle the event

### GstBase.CollectPadsQueryFunction

    function GstBase.CollectPadsQueryFunction(pads: GstBase.CollectPads, pad: GstBase.CollectData, query: Gst.Query, user_data: Object): {
        // javascript wrapper for 'GstCollectPadsQueryFunction'
    }

A function that will be called while processing a query. It takes ownership of the query and is responsible for chaining up (to events downstream (with Gst.Pad.prototype.event_default).

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`pad` (GstBase.CollectData) –

the Gst.Pad that received an event

`query` (Gst.Query) –

the Gst.Event received

`user_data` (Object) –

user data passed to GstBase.CollectPads.prototype.set_query_function

Returns (Number) –

true if the pad could handle the event

### GstBase.CollectPadsQueryFunction

    def GstBase.CollectPadsQueryFunction (pads, pad, query, *user_data):
        #python wrapper for 'GstCollectPadsQueryFunction'

A function that will be called while processing a query. It takes ownership of the query and is responsible for chaining up (to events downstream (with Gst.Pad.event_default).

Parameters:

`pads` (GstBase.CollectPads) –

the GstBase.CollectPads that triggered the callback

`pad` (GstBase.CollectData) –

the Gst.Pad that received an event

`query` (Gst.Query) –

the Gst.Event received

`user_data` (variadic) –

user data passed to GstBase.CollectPads.set_query_function

Returns (bool) –

True if the pad could handle the event

The results of the search are